// DlgParameters.cpp : implementation file
//

#include "stdafx.h"
#include "OPN2001_DEMO.h"
#include "DlgParameters.h"
#include "csp2.h"
#include ".\GridCtrl\GridCellCombo.h"
#include ".\GridCtrl\GridCellNumeric.h"

typedef struct 
{
	LPCWSTR szParameter;
	short	nTypeMin;	// if nTypeMin is 9999 then combobox or 9998 as special input (scratch pad)
	short	nTypeMax;	// if nTypeMin is 9999 then nTypeMax selects the combobox type	
	short	nOffset;	// Some comboboxes start with another value then zero the use the nOffset value
	BYTE	nParamNr;
}ParamOptions;

ParamOptions paramOptions [] = 
{
	L"GS1 DataBar",                     9999,   10,  0,  20,
	L"Code-39",							9999,	0,	0,	31,
	L"UPC",								9999,	0,	0,	9,
	L"Code-128",						9999,	0,	0,	8,
	L"Code-39 Full ASCII",				9999,	0,	0,	54,
	L"UPC Supps",						9999,	2,	0,	53,
	L"Convert UPC-E to A",				9999,	0,	0,	41,
	L"Convert EAN-8 to EAN-13",			9999,	0,	0,	42,
	L"Convert EAN-8 to EAN-13 Type",	9999,	0,	0,	55,
	L"Send UPC-A Check Digit",			9999,	0,	0,	43,
	L"Send UPC-E Check Digit",			9999,	0,	0,	44,
	L"Code-39 Check Digit",				9999,	0,	0,	46,
	L"Xmit Code-39 Check Digit",		9999,	0,	0,	45,
	L"UPC-E Preamble",					9999,	3,	0,	37,
	L"UPC-A Preamble",					9999,	3,	0,	36,
	L"EAN-128",							9999,	0,	0,	52,
	L"Coupon Code",						9999,	0,	0,	56,
	L"I 2 of 5",						9999,	0,	0,	58,
	L"I 2of5 Check Digit",				9999,	4,	0,	65,
	L"Xmit I 2of5 Check Digit",			9999,	0,	0,	64,
	L"Convert ITF14 to EAN 13",			9999,	0,	0,	63,
	L"I 2of5 Length 1",					0,		30, 0,	59,
	L"I 2of5 Length 2",					0,		30,	0,	60,
	L"D 2of5",							9999,	0,	0,	57,
	L"D 2of5 Length 1",					0,		30,	0,	61,
	L"D 2of5 Length 2",					0,		30,	0,	62,
	L"UPC/EAN Security",				0,		3,	0,	47,
	L"UPC/EAN Supplemental Redundancy (No_supp_max)", 2, 20, 0,	48,
	L"Scanner On-Time",					10,		100,0,	17,
	L"Volume",							9999,	1,	0,	2,
	L"Comm awake time",					1,		6,	0,	32,
	L"Baudrate",						9999,	5,	3,	13,
	L"Baud Switch Delay",				0,		100,0,	29,
	L"Reset Baudrates",					9999,	0,	0,	28,
	L"Reject redundant barcode",		9999,	0,	0,	4,
	L"Host Connect Beep",				9999,	0,	0,	10,
	L"Host Complete Beep",				9999,	0,	0,	11,
	L"Low-battery indication",			9999,	6,	0,	7,
	L"Auto Clear",						9999,	0,	0,	15,
	L"Delete Enable",					9999,	7,	0,	33,
	L"Data Protection",					9999,	0,	0,	49,
	L"Memory full indication",			9999,	0,	0,	50,
	L"Memory Low Indication",			9999,	0,	0,	51,
	L"Max Barcode Length",				1,		99,	0,	34,		// Max barcode length changed from 30 to 99 for Ronny.
	L"Good decode LED on time",			9999,	8,	1,	30,
	L"Store RTC",						9999,	0,	0,	35,
	L"ASCII mode",						9999,	9,	0,	79,
	L"Beeper Toggle",					9999,	1,	0,	85,
	L"Beeper Auto On",					9999,	1,	0,	86,
	L"Laser mode",						9999,	11,	0,	5,
	L"Aiming On-Time",					10,		100,0,	19,
//	L"Scratch Pad",						9998,	0,	0,	38
};

#define MAX_OPN_PARAMETERS ( sizeof(paramOptions) / sizeof(ParamOptions))


// CDlgParameters dialog

IMPLEMENT_DYNAMIC(CDlgParameters, CDialog)

CDlgParameters::CDlgParameters(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgParameters::IDD, pParent)
	, m_pProgWnd( NULL )
{
	// Enable disable string options
	m_paramStringOptions[ 0 ].Add(L"0 - Disable");
	m_paramStringOptions[ 0 ].Add(L"1 - Enable");

	// On off string options
	m_paramStringOptions[ 1 ].Add( L"0 - Off");
	m_paramStringOptions[ 1 ].Add( L"1 - On");

	// UPC Supps string options
	m_paramStringOptions[ 2 ].Add( L"0 - No Supps");
	m_paramStringOptions[ 2 ].Add( L"1 - Supps only");
	m_paramStringOptions[ 2 ].Add( L"2 - Auto-D");

	// UPC-A and UPC-E preamble string options
	m_paramStringOptions[ 3 ].Add( L"0 - None");
	m_paramStringOptions[ 3 ].Add( L"1 - System char");
	m_paramStringOptions[ 3 ].Add( L"2 - Sys char & country code");

	// I 2of5 Check Digit string options
	m_paramStringOptions[ 4 ].Add( L"0 - Disabled");
	m_paramStringOptions[ 4 ].Add( L"1 - USS check digit");
	m_paramStringOptions[ 4 ].Add( L"2 - OPCC check digit");

	// Baudrate string options
	m_paramStringOptions[ 5 ].Add( L"3 - 300");
	m_paramStringOptions[ 5 ].Add( L"4 - 600");
	m_paramStringOptions[ 5 ].Add( L"5 - 1200");
	m_paramStringOptions[ 5 ].Add( L"6 - 2400");
	m_paramStringOptions[ 5 ].Add( L"7 - 4800");
	m_paramStringOptions[ 5 ].Add( L"8 - 9600");
	m_paramStringOptions[ 5 ].Add( L"9 - 19200");

	// Low-Battery Indication string options
	m_paramStringOptions[ 6 ].Add( L"0 - No indication / No operation");
	m_paramStringOptions[ 6 ].Add( L"1 - No Indication / Allow operation");
	m_paramStringOptions[ 6 ].Add( L"2 - Indicate / No operation");
	m_paramStringOptions[ 6 ].Add( L"3 - Indicate / Allow operation.");

	// Delete enable string options
	m_paramStringOptions[ 7 ].Add( L"0 - Delete OFF/Clear all OFF/Set dflt OFF");
	m_paramStringOptions[ 7 ].Add( L"1 - Delete OFF/Clear all ON/Set dflt OFF");
	m_paramStringOptions[ 7 ].Add( L"2 - Delete ON/Clear all OFF/Set dflt OFF");
	m_paramStringOptions[ 7 ].Add( L"3 - Delete ON/Clear all ON/Set dflt OFF");
	m_paramStringOptions[ 7 ].Add( L"4 - Delete OFF/Clear all OFF/Set dflt ON");
	m_paramStringOptions[ 7 ].Add( L"5 - Delete OFF/Clear all ON/Set dflt ON");
	m_paramStringOptions[ 7 ].Add( L"6 - Delete ON/Clear all OFF/Set dflt ON");
	m_paramStringOptions[ 7 ].Add( L"7 - Delete ON/Clear all ON/Set dflt ON");

	// Good Decode LED On Time string options
	m_paramStringOptions[ 8 ].Add( L"1 - 250 ms");
	m_paramStringOptions[ 8 ].Add( L"2 - 500 ms");
	m_paramStringOptions[ 8 ].Add( L"3 - 750 ms");
	m_paramStringOptions[ 8 ].Add( L"4 - 1000 ms");

	// ASCII mode string options
	m_paramStringOptions[ 9 ].Add( L"0 - Like encrypted data");
	m_paramStringOptions[ 9 ].Add( L"1 - As ASCII strings");

	m_paramStringOptions[10].Add(L"0 - disable");
	m_paramStringOptions[10].Add(L"1 - Enable GS1 Databar Limited");
	m_paramStringOptions[10].Add(L"2 - Enable GS1 Databar");	
	m_paramStringOptions[10].Add(L"3 - Enable GS1 Databar and Limited");
	m_paramStringOptions[10].Add(L"4 - Enable GS1 Databar Expanded");
	m_paramStringOptions[10].Add(L"5 - Enable GS1 Databar Limited and Exp.");
	m_paramStringOptions[10].Add(L"6 - Enable GS1 Databar and Expanded");
	m_paramStringOptions[10].Add(L"7 - Enable GS1 Databar all symbologies");

	m_paramStringOptions[11].Add(L"0 - Normal");
	m_paramStringOptions[11].Add(L"1 - Aiming help");
	m_paramStringOptions[11].Add(L"2 - Small laser");	
}

CDlgParameters::~CDlgParameters()
{
}

void CDlgParameters::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_GRID_PARAMETERS, m_gridParam);
}


BEGIN_MESSAGE_MAP(CDlgParameters, CDialog)
	ON_NOTIFY(GVN_ENDLABELEDIT, IDC_GRID_PARAMETERS, OnGridEndEdit)
	ON_NOTIFY(GVN_SELCHANGED, IDC_GRID_PARAMETERS, OnGridEndSelChange)
	ON_BN_CLICKED(IDC_BTN_DEFAULT, &CDlgParameters::OnBnClickedBtnDefault)
	ON_BN_CLICKED(IDC_BTN_SETTINGS, &CDlgParameters::OnBnClickedBtnSettings)
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// CDlgParameters message handlers
BOOL CDlgParameters::OnInitDialog()
{
	CDialog::OnInitDialog();

	CRect rect;
	m_gridParam.SetColumnCount( 2 );
	m_gridParam.SetRowCount( MAX_OPN_PARAMETERS );
	m_gridParam.SetFixedColumnCount();
	m_gridParam.GetClientRect( &rect );
	m_gridParam.SetColumnWidth( 0, ((rect.Width() / 5) *4)-14);
	m_gridParam.SetColumnWidth( 1, (rect.Width() / 5 )+18); 
	m_gridParam.SetFixedColumnSelection( FALSE );
	m_gridParam.SetFixedRowSelection( FALSE );
	m_gridParam.EnableTitleTips( FALSE );

	// Create a progress window
	if( m_pProgWnd == NULL )
		m_pProgWnd = new CProgressWnd( this, _T("Progress"), 0 );
	if( m_pProgWnd != NULL )
		m_pProgWnd->Hide();

	// Fill the list control
	FillListControl(); 

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDlgParameters::FillListControl( void )
{
	long lRet;
	int nPercentage;
	char szParam[ 2 ];
	CString strItem;

	m_pProgWnd->Show();
	for( int x = 0; x < MAX_OPN_PARAMETERS; x++ )
	{
		m_gridParam.SetItemText( x, 0, paramOptions[ x ].szParameter );
		m_pProgWnd->SetText( paramOptions[ x ].szParameter );
		nPercentage = ((x + 1)*100) / MAX_OPN_PARAMETERS; 
		m_pProgWnd->SetPos( (int) nPercentage );

		if( (lRet =  csp2GetParam( paramOptions[ x ].nParamNr, szParam, 1L )) != STATUS_OK )
			ShowErrorMessage( lRet );
//		if( lRet == STATUS_OK )
//		{
//			strItem.Format(L"%d", szParam[ 0 ]);
//		}

		if( paramOptions[ x ].nTypeMin == 9999 )
		{
			szParam[ 0 ] -= (char)paramOptions[ x ].nOffset;
			// Combobox type 
			m_gridParam.SetCellType( x, 1, RUNTIME_CLASS(CGridCellCombo));

			if( szParam[ 0 ] < 0 || szParam[ 0 ] >= m_paramStringOptions[ paramOptions[ x ].nTypeMax ].GetCount())
				szParam[ 0 ] = 0;

			m_gridParam.SetItemText( x, 1, m_paramStringOptions[ paramOptions[ x ].nTypeMax ].ElementAt( szParam[ 0 ] ));
			CGridCellCombo *pCell = (CGridCellCombo*) m_gridParam.GetCell( x, 1 );
			pCell->SetOptions( m_paramStringOptions[ paramOptions[ x ].nTypeMax ] );
			pCell->SetStyle( CBS_DROPDOWNLIST );
			
		}
		else if( paramOptions[ x ].nTypeMin == 9998 )
		{
			// Special option
			m_gridParam.SetItemState( x, 1, m_gridParam.GetItemState( x, 1) | GVIS_READONLY);
		}
		else
		{
			// Min max options
			m_gridParam.SetCellType( x, 1, RUNTIME_CLASS( CGridCellNumeric ));
			if( szParam[ 0 ] < (char)paramOptions[ x ].nTypeMin || szParam[ 0 ] > (char)paramOptions[ x ].nTypeMax )
				szParam[ 0 ] = (char)paramOptions[ x ].nTypeMin;

			strItem.Format( L"%d", (int)szParam[ 0 ] );
			m_gridParam.SetItemText( x, 1, strItem );
			CGridCellNumeric *pCell = (CGridCellNumeric*) m_gridParam.GetCell( x, 1 );
		}
	}
	m_gridParam.UpdateData();
	m_gridParam.Invalidate();
	m_pProgWnd->Hide();
}


// GVN_ENDLABELEDIT
void CDlgParameters::OnGridEndEdit(NMHDR *pNotifyStruct, LRESULT* pResult)
{
	int nValue;
    NM_GRIDVIEW* pItem = (NM_GRIDVIEW*) pNotifyStruct;
	CGridCellNumeric *pCell = (CGridCellNumeric*)m_gridParam.GetCell( pItem->iRow, pItem->iColumn );
	nValue = _ttoi( pCell->GetText());

	if( paramOptions[ pItem->iRow ].nTypeMin == 9999 || paramOptions[ pItem->iRow ].nTypeMin == 9998 )
	{
		*pResult = 0;
	}
	else
	{
		if( nValue < paramOptions[ pItem->iRow ].nTypeMin || nValue > paramOptions[ pItem->iRow ].nTypeMax )
			*pResult = -1; // Wrong value
		else
			*pResult = 0; // OK
	}
}

// GVN_SELCHANGED
void CDlgParameters::OnGridEndSelChange(NMHDR *pNotifyStruct, LRESULT* /*pResult*/)
{
    NM_GRIDVIEW* pItem = (NM_GRIDVIEW*) pNotifyStruct;
	if( pItem->iColumn == 1 && paramOptions[ pItem->iRow ].nTypeMin == 9998 )
	{
		if( paramOptions[ pItem->iRow ].nTypeMax == 0 )
		{
			// scratch pad option
			::MessageBox( NULL, L"Scratch pad", L"Information", MB_OK);
			return;
		}
	}
}

void CDlgParameters::OnBnClickedBtnDefault()
{
	long lRet;

	lRet = csp2SetDefaults();
	if( lRet != STATUS_OK )
	{
		ShowErrorMessage( lRet );
		return;
	}
	FillListControl();
}


void CDlgParameters::OnBnClickedBtnSettings()
{
	long lRet;
	int nPercentage;
	char szParam[ 2 ];
	CString strItem;

	m_pProgWnd->Show();
	for( int x = 0; x < MAX_OPN_PARAMETERS; x++ )
	{
		m_pProgWnd->SetText( paramOptions[ x ].szParameter );
		nPercentage = ((x + 1)*100) / MAX_OPN_PARAMETERS; 
		m_pProgWnd->SetPos( (int) nPercentage );

		if( paramOptions[ x ].nTypeMin == 9999 )
		{
			szParam[ 0 ] = 0;
			// combobox type
			for( int itemnr = 0; itemnr < m_paramStringOptions[ paramOptions[ x ].nTypeMax ].GetCount(); itemnr++ )
			{
				CString strData = m_paramStringOptions[ paramOptions[ x ].nTypeMax ].ElementAt( itemnr ) ;
				if( m_paramStringOptions[ paramOptions[ x ].nTypeMax ].ElementAt( itemnr ).Compare( m_gridParam.GetCell( x, 1 )->GetText() ) == 0)
				{
					szParam[ 0 ] = itemnr + paramOptions[ x ].nOffset;
					break;
				}
			}
		}
		else if( paramOptions[ x ].nTypeMin == 9998 )
		{
			// special options, e.g. scratch pad
		}
		else
		{
			szParam[ 0 ] = _ttoi( m_gridParam.GetCell( x, 1)->GetText());
		}
		if( (lRet = csp2SetParam( paramOptions[ x ].nParamNr, szParam, 1L )) != STATUS_OK )
			ShowErrorMessage( lRet );
	}
	m_pProgWnd->Hide();
}


void CDlgParameters::OnClose()
{
	if( m_pProgWnd != NULL )
		delete m_pProgWnd;
	m_pProgWnd = NULL;
	CDialog::OnClose();
	EndDialog( IDOK );
}

void CDlgParameters::OnOK()
{
}

void CDlgParameters::OnCancel()
{
}


void CDlgParameters::ShowErrorMessage( long lErrorCode )
{
	CString strMessage;

	switch( lErrorCode )
	{
	case STATUS_OK:
		strMessage = L"Status OK";
		break;
	case COMMUNICATIONS_ERROR:
		strMessage = L"Communication error!";
		break;
	case BAD_PARAM:       
		strMessage = L"Bad parameter!";
		break;
	case SETUP_ERROR:
		strMessage = L"Setup error!";
		break;
	case INVALID_COMMAND_NUMBER:
		strMessage = L"Invalid command number!";
		break;
	case COMMAND_LRC_ERROR:
		strMessage = L"Checksum error!";
		break;
	case RECEIVED_CHARACTER_ERROR:
		strMessage = L"Wrong character received!";
		break;
	case GENERAL_ERROR:
		strMessage = L"General error!";
		break;
	case FILE_NOT_FOUND:
		strMessage = L"File not found!";
		break;
	case ACCESS_DENIED:
		strMessage = L"Access denied!";
		break;
	default:
		strMessage = L"Unknow error!!!";
		break;
	}
	MessageBox( strMessage, L"Error", MB_OK | MB_ICONERROR );
}

